/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.niederschrift.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung;
import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungUK;

public abstract class AbstractNiederschriftStatusAenderungDAO extends de.ivu.elect.jee.entity.AbstractDAO<NiederschriftStatusAenderung,
        de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungPK
    , NiederschriftStatusAenderungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractNiederschriftStatusAenderungDAO.class);

  public AbstractNiederschriftStatusAenderungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public NiederschriftStatusAenderung findByPrimaryKey(
        de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected NiederschriftStatusAenderung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(NiederschriftStatusAenderung.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: DeleteByWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE from NiederschriftStatusAenderung o where o.niederschrift.id IN (SELECT n.id FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet.wahl = ?1)<br>
      * SQL: <br>
      */
     public Integer deleteDeleteByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("NIEDERSCHRIFT_STATUS_AENDERUNG.DeleteByWahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("NiederschriftStatusAenderung, deleteDeleteByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteDeleteByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: NiederschriftAndMaxZeitstempelNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = ?1 )<br>
      * SQL: <br>
      */
     public NiederschriftStatusAenderung findByNiederschriftAndMaxZeitstempel( @javax.annotation.Nonnull de.ivu.elect.business.niederschrift.entity.Niederschrift niederschrift) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.niederschrift.entity.Niederschrift niederschriftCheckedAndAttached =  checkAndAttach(niederschrift, de.ivu.elect.business.niederschrift.entity.Niederschrift.class, "niederschrift"); ;
		  
                              return
                    (NiederschriftStatusAenderung)
                              getEntityManager().
                                createNamedQuery("NIEDERSCHRIFT_STATUS_AENDERUNG.NiederschriftAndMaxZeitstempel")
                              .setParameter(1, niederschriftCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByNiederschriftAndMaxZeitstempel - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("NiederschriftStatusAenderung, findByNiederschriftAndMaxZeitstempel - NonUniqueResultException, Parameter: "
           + ", niederschrift:'"+niederschrift+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByNiederschriftAndMaxZeitstempel(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndMaxZeitstempelNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift.wahldurchfuehrungsgebiet.wahl = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = nsa.niederschrift )<br>
      * SQL: <br>
      */
     public java.util.List<NiederschriftStatusAenderung> findByWahlAndMaxZeitstempel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("NIEDERSCHRIFT_STATUS_AENDERUNG.WahlAndMaxZeitstempel")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndMaxZeitstempel - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("NiederschriftStatusAenderung, findByWahlAndMaxZeitstempel - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndMaxZeitstempel(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungUK uk,
        de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung findByUK(de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}